=== debian/changelog ===
ros-noetic-fuse-constraints (0.4.2-1focal) focal; urgency=high

  * Adding roslint dependency to fuse_viz (#231 <https://github.com/locusrobotics/fuse/issues/231>)
    * Adding roslint dependency to fuse_viz
    * Silence CMP0048 warnings
  * Contributors: Tom Moore

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 19 Jul 2021 23:00:00 -0000

ros-noetic-fuse-constraints (0.4.1-1focal) focal; urgency=high

  * Use analytic relative pose 2d cost function (#193 <https://github.com/locusrobotics/fuse/issues/193>)
    * Use analytic relative pose 2d cost function
    * Add analytic NormalDeltaPose2D cost function
    * Use analytic NormalDeltaPose2D cost function in
    RelativePose2DStampedConstraint
    * Test NormalDeltaPose2D jacobians are correct, comparing against
    NormalDeltaPose2DCostFunctor using automatic differentiation
    * Benchmark NormalDeltaPose2D vs NormalDeltaPose2DCostFunctor using
    automatic differentiation for 1, 2 and 3 residuals. The latency
    speedup is approximately 1.35, 1.49 and 1.55, respectively.
  * Use analytic absolute pose 2d cost function (#192 <https://github.com/locusrobotics/fuse/issues/192>)
    * Add analytic NormalPriorPose2D cost function
    * Use analytic NormalPriorPose2D cost function in
    AbsolutePose2DStampedConstraint
    * Test NormalPriorPose2D jacobians are correct, comparing against
    NormalPriorPose2DCostFunctor using automatic differentiation
    * Benchmark NormalPriorPose2D vs NormalPriorPose2DCostFunctor using
    automatic differentiation for 1, 2 and 3 residuals. The latency
    speedup is approximately 2.36, 2.76 and 3.44, respectively.
  * Fix roslint 0.12.0 (#186 <https://github.com/locusrobotics/fuse/issues/186>)
    * Fix roslint 0.12.0 include_what_you_use warnings
    Mostly for:
    * std::move -> #include <utility>
    * std::make_shared and similar -> #include <memory>
    * Remove static string variable not permitted by roslint 0.12.0, using a test fixture where needed.
  * Fix Unicycle2DIgnition set_pose (#154 <https://github.com/locusrobotics/fuse/issues/154>)
    * Initialize StateHistoryElement::velocity_yaw
    * Process ignition transactions individually
    * Call motion model generator with last stamp
    * Skip optimization cycle if transaction is empty
  * Fix compute elimination order with orphan variables (#136 <https://github.com/locusrobotics/fuse/issues/136>)
    * Test computeEliminationOrder with orphan variables
    * Fix computeEliminationOrder with orphan variables
  * Fix get constraints with lvalue iterator input (#134 <https://github.com/locusrobotics/fuse/issues/134>)
    * Change getConstraints signature to return iterator
    * Update marginalize code to fix the previous usage error
  * Support printing VariableConstraints objects (#132 <https://github.com/locusrobotics/fuse/issues/132>)
  * Add fuse_loss pkg with plugin-based loss functions (#118 <https://github.com/locusrobotics/fuse/issues/118>)
  * Removed the explicit '-std=c++14' compile flag (#119 <https://github.com/locusrobotics/fuse/issues/119>)
    * Removed the explicit '-std=c++14' compile flag
    * Changed the CXX_STANDARD setting to be per-target instead of global
    * Added the CXX_STANDARD_REQUIRED setting to all targets
  * Revert "Fix build with ceres 2.0 with CMake < 3.8 (#106 <https://github.com/locusrobotics/fuse/issues/106>)" (#120 <https://github.com/locusrobotics/fuse/issues/120>)
    This reverts commit 9933456ecc24ba9b649a8a2885be3f852306efee.
  * Wrap normal delta pose 2d orientation angle error (#122 <https://github.com/locusrobotics/fuse/issues/122>)
  * fix compilation in Kinetic (#112 <https://github.com/locusrobotics/fuse/issues/112>)
  * Support empty linear terms in marginalizeNext (#111 <https://github.com/locusrobotics/fuse/issues/111>)
    * Enforce constness
    * Unshadow variable_uuid in inner for loop
    * Support empty linear terms in marginalizeNext
  * Fix build with ceres 2.0 with CMake < 3.8 (#106 <https://github.com/locusrobotics/fuse/issues/106>)
    * Note that while the Ceres 2.0 build completes, there may still be some lingering issues.
  * [RST-1951] speed optimizations (#100 <https://github.com/locusrobotics/fuse/issues/100>)
    * Improved random UUID generator
    * Minor Eigen assignment speed improvements
  * [RST-2427] Added a 'source' field to the constraints. This is an API-breaking change. (#101 <https://github.com/locusrobotics/fuse/issues/101>)
  * [RST-2340] Add serialization support to fuse (#98 <https://github.com/locusrobotics/fuse/issues/98>)
  * Fix -Wall -Wextra warnings in tests (#80 <https://github.com/locusrobotics/fuse/issues/80>)
  * Fix -Wall -Wextra warnings (#77 <https://github.com/locusrobotics/fuse/issues/77>)
  * Contributors: Davide Faconti, Enrique Fernandez Perdomo, Stephen Williams

 -- Stephen Williams <swilliams@locusrobotics.com>  Mon, 12 Jul 2021 23:00:00 -0000

ros-noetic-fuse-constraints (0.4.0-1focal) focal; urgency=high

  * Depend on libceres-dev instead of ceres-solver (#71 <https://github.com/locusrobotics/fuse/issues/71>)
  * [RST-2144] Support proper Eigen memory alignment (#65 <https://github.com/locusrobotics/fuse/issues/65>)
  * [RST-2088] Fix bug causing bad marginal computations occasionally (#60 <https://github.com/locusrobotics/fuse/issues/60>)
  * [RST-1747] fixed lag smoother implementation (#52 <https://github.com/locusrobotics/fuse/issues/52>)
  * Modified Variable class to make the UUID immutable (#55 <https://github.com/locusrobotics/fuse/issues/55>)
  * RST-2025 Fixing size issues (#53 <https://github.com/locusrobotics/fuse/issues/53>)
    * Fixing size issue with 2D poses
    * Fixed the size check in MarginalConstraint (#54 <https://github.com/locusrobotics/fuse/issues/54>)
  * [RST-1745] Added a marginalizeVariables() function (#48 <https://github.com/locusrobotics/fuse/issues/48>)

