=== debian/control ===
Source: ros-noetic-fuse-constraints
Section: misc
Priority: optional
Maintainer: Stephen Williams <swilliams@locusrobotics.com>
Build-Depends: debhelper (>= 9.0.0), libbenchmark-dev, libceres-dev, libeigen3-dev, libsuitesparse-dev, ros-noetic-catkin, ros-noetic-fuse-core, ros-noetic-fuse-graphs, ros-noetic-fuse-variables, ros-noetic-geometry-msgs, ros-noetic-pluginlib, ros-noetic-roscpp, ros-noetic-roslint, ros-noetic-rostest
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-fuse-constraints
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libceres-dev, libeigen3-dev, libsuitesparse-dev, ros-noetic-fuse-core, ros-noetic-fuse-graphs, ros-noetic-fuse-variables, ros-noetic-geometry-msgs, ros-noetic-pluginlib, ros-noetic-roscpp
Description: The fuse_constraints package provides a set of commonly used constraint types, such as direct measurements on state variables (absolute constraints) or measurements of the state changes (relative constraints).
